function y=rle(x)
%RLE Run-length encoding scheme.
%   
%   y=rle(x) returns the run-length encoded sequence y based on the 
%   input x.
%
%   See rld.
if size(x,1)>1
    x=x';
end
rl=-1;
past=x(1);
y(1)=x(1);
yi=2;
for i=2:length(x)
    if (past==x(i))
        rl=rl+1;
    elseif ((past~=x(i))&&(rl>-1))
        y(yi)=past;
        y(yi+1)=rl;
        y(yi+2)=x(i);
        rl=-1;
        past=x(i);
        yi=yi+3;
    else
        y(yi)=x(i);
        yi=yi+1;
        past=x(i);
    end
end
if rl>-1
    y(yi)= past;
    y(yi+1)=rl;
end
